// Author O((Mx + My + Nx + Ny) log (Mx + My + Nx + Ny))

#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define ll long long
#define mp make_pair

using namespace std;

const int MAX_N = 105555;
const int MAX_M = 105555;

struct DSU {
	int p[MAX_N];
	DSU() {
		memset(p, -1, sizeof(p));
	}
	int who(int x) {
		if (p[x] == -1) return x;
		return p[x] = who(p[x]);
	}
	void un(int x, int y) {
		x = who(x);
		y = who(y);
		if (rand() & 1) {
			p[x] = y;
		} else {
			p[y] = x;
		}
	}
};

struct Graph {
	int last[MAX_N], n, m, e;
	int pred[MAX_M], v[MAX_M], w[MAX_M];
	Graph() {
		memset(last, -1, sizeof(last));
		e = 0;
	}
	void add(int a, int b, int we) {
		pred[e] = last[a];
		v[e] = b;
		w[e] = we;
		last[a] = e;
		e++;
	}
	void read() {
		scanf("%d%d", &n, &m);
		for (int i = 0; i < m; i++) {
			int a, b, we;
			scanf("%d%d%d", &a, &b, &we);
			a--; b--;
			add(a, b, we);
			add(b, a, we);
		}
	}
	ll dijkstra() {
		priority_queue<pair<ll, int>, vector<pair<ll, int> >, greater<pair<ll, int> > > Q;
		Q.push(mp(0, 0));
		vector<int> used(n, false);
		while (!Q.empty()) {
			pair<ll, int> cur = Q.top(); Q.pop();
			if (used[cur.second]) continue;
			used[cur.second] = true;
			if (cur.second == n - 1) 
				return cur.first;
			for (int i = last[cur.second]; i >= 0; i = pred[i]) {
				if (used[v[i]]) continue;
				Q.push(mp(cur.first + w[i], v[i]));
			}
		}
		assert(0);
	}
};

Graph a, b;

DSU x, y;
pair<int, pair<int, int> > edges[2 * MAX_M];

int main() {
	#ifndef SHTRIX
	freopen("cartesius.dat", "rt", stdin);
	freopen("cartesius.sol", "wt", stdout);
	#endif
	int q;
	scanf("%d", &q);
	if (q == 1) {
		a.read();
		b.read();
		cout << a.dijkstra() + b.dijkstra() << endl;
	} else {
		ll ans = 0;
		int n, m, k, l, c = 0;
		scanf("%d%d", &n, &m);
		for (int i = 0; i < m; i++) {
			int a, b, w;
			scanf("%d%d%d", &a, &b, &w);
			edges[c++] = mp(w, mp(a, b));
		}
		scanf("%d%d", &k, &l);
		for (int i = 0; i < l; i++) {
			int a, b, w;
			scanf("%d%d%d", &a, &b, &w);
			edges[c++] = mp(w, mp(-a, -b));
		}
		sort(edges, edges + c);
		int cntx = n, cnty = k;
		for (int i = 0; i < m + l; i++) {
			int a, b, w;
			w = edges[i].first;
			a = edges[i].second.first;
			b = edges[i].second.second;
			bool isx = true;
			if (a < 0) {
				a *= -1;
				b *= -1;
				isx = false;
			}
			a--;
			b--;
			if (isx) {
				if (x.who(a) != x.who(b)) { 
					ans += (ll)(cnty) * w;
					x.un(a, b);
					cntx--;
				}
			} else {
				if (y.who(a) != y.who(b)) {
					ans += (ll) (cntx) * w;
					y.un(a, b);
					cnty--;
				}
			}
		}

		cout << ans << endl;
	}

}
