// O((Nx * Ny) * (Nx * Ny + Mx + My))
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <cstdio>
#include <cstdlib>
#include <cstring>

using namespace std;

const int N = 1111;

struct Graph {
	int n, m;
	vector<int> G[N], W[N];
	void read() {
		scanf("%d%d", &n, &m);
		for (int i = 0; i < m; i++) {
			int a, b, w;
			scanf("%d%d%d", &a, &b, &w);
			a--; b--;
			G[a].push_back(b);
			W[a].push_back(w);
			G[b].push_back(a);
			W[b].push_back(w);
		}
	}
} X, Y;


#define ll long long
#define INFLL 1000000000000000000LL

inline void upd(ll &x, ll y) {
	if (y < x) x = y;
}

bool used[N][N];
ll d[N][N];

ll dijkstra() {
	for (int i = 0; i < X.n; i++)
		for (int j = 0; j < Y.n; j++)
			d[i][j] = INFLL;
	memset(used, 0, sizeof(used));
	d[0][0] = 0;
	while (true) {
		int bx = -1, by = -1;
		ll val = INFLL;
		for (int i = 0; i < X.n; i++)
			for (int j = 0; j < Y.n; j++)
				if (!used[i][j])
					if (val > d[i][j]) {
						val = d[i][j];
						bx = i;
						by = j;
					}
		if (val == INFLL) break;
		used[bx][by] = true;
		for (int i = 0; i < X.G[bx].size(); i++) {
			int v = X.G[bx][i], w = X.W[bx][i];
			upd(d[v][by], d[bx][by] + w);
		}
		for (int i = 0; i < Y.G[by].size(); i++) {
			int v = Y.G[by][i], w = Y.W[by][i];
			upd(d[bx][v], d[bx][by] + w);
		}		
	}
	return d[X.n - 1][Y.n - 1];
}

ll prim() {
	for (int i = 0; i < X.n; i++)
		for (int j = 0; j < Y.n; j++)
			d[i][j] = INFLL;
	memset(used, 0, sizeof(used));
	d[0][0] = 0;
	ll sum = 0;
	while (true) {
		int bx = -1, by = -1;
		ll val = INFLL;
		for (int i = 0; i < X.n; i++)
			for (int j = 0; j < Y.n; j++)
				if (!used[i][j])
					if (val > d[i][j]) {
						val = d[i][j];
						bx = i;
						by = j;
					}
		if (val == INFLL) break;
		sum += val;
		used[bx][by] = true;
		for (int i = 0; i < X.G[bx].size(); i++) {
			int v = X.G[bx][i], w = X.W[bx][i];
			upd(d[v][by], w);
		}
		for (int i = 0; i < Y.G[by].size(); i++) {
			int v = Y.G[by][i], w = Y.W[by][i];
			upd(d[bx][v], w);
		}		
	}
	return sum;
}

int main() {
	#ifndef SHTRIX
	freopen("cartesius.dat", "rt", stdin);
	freopen("cartesius.sol", "wt", stdout);
	#endif
	int Q;
	cin >> Q;
	X.read();
	Y.read();
	if (Q == 1) {
		cout << dijkstra() << endl;
	} else {
		cout << prim() << endl;
	}
}